/*
 * drivertab.c:
 *	define the available director, router, transport and lookup
 *	drivers for use by smail.
 *
 * THIS FILE IS GENERATED AUTOMATICALLY BY THE SCRIPT mkdrivtab.sh FROM
 * THE DRIVER CONFIGURATION FILE ../conf/driver/arpa-network
 * MAKE CHANGES TO THE DRIVER CONF FILE AND REBUILD RATHER THAN EDITING
 * THIS FILE DIRECTLY.
 */

#include <stdio.h>
#include "defs.h"
#include "smail.h"
#include "addr.h"
#include "direct.h"
#include "route.h"
#include "transport.h"

extern struct addr *dtd_aliasinclude();
extern char *dtb_aliasinclude();
extern void dtp_aliasinclude();
extern struct addr *dtd_forwardinclude();
extern char *dtb_forwardinclude();
extern void dtp_forwardinclude();
extern struct addr *dtd_genericinclude();
extern char *dtb_genericinclude();
extern void dtp_genericinclude();
extern struct addr *dtd_aliasfile();
extern char *dtb_aliasfile();
extern void dtp_aliasfile();
extern struct addr *dtd_forwardfile();
extern char *dtb_forwardfile();
extern void dtp_forwardfile();
extern struct addr *dtd_user();
extern char *dtb_user();
extern void dtp_user();
extern struct addr *dtd_altuser();
extern char *dtb_altuser();
extern void dtp_altuser();
extern struct addr *dtd_smartuser();
extern char *dtb_smartuser();
extern void dtp_smartuser();
extern void rtd_pathalias();
extern char *rtb_pathalias();
extern void rtp_pathalias();
extern void rtc_uuname();
extern void rtd_uuname();
extern void rtf_uuname();
extern char *rtb_uuname();
extern void rtp_uuname();
extern void rtd_smarthost();
extern char *rtb_smarthost();
extern void rtp_smarthost();
extern void rtd_reroute();
extern char *rtb_reroute();
extern void rtp_reroute();
extern void rtd_rewrite();
extern char *rtb_rewrite();
extern void rtp_rewrite();
extern void rtd_queryprogram();
extern char *rtb_queryprogram();
extern void rtp_queryprogram();
extern void rtd_gethostbyname();
extern char *rtb_gethostbyname();
extern void rtp_gethostbyname();
extern void rtd_gethostbyaddr();
extern char *rtb_gethostbyaddr();
extern void rtp_gethostbyaddr();
extern void rtd_bind();
extern char *rtb_bind();
extern void rtp_bind();
extern void tpd_pipe();
extern char *tpb_pipe();
extern void tpp_pipe();
extern void tpd_appendfile();
extern char *tpb_appendfile();
extern void tpp_appendfile();
extern void tpd_smtp();
extern char *tpb_smtp();
extern void tpp_smtp();
extern void tpd_tcpsmtp();
extern char *tpb_tcpsmtp();
extern void tpp_tcpsmtp();
 
struct direct_driver direct_drivers[] = {
    { "aliasinclude",NULL,dtd_aliasinclude,NULL,dtb_aliasinclude,dtp_aliasinclude },
    { "forwardinclude",NULL,dtd_forwardinclude,NULL,dtb_forwardinclude,dtp_forwardinclude },
    { "genericinclude",NULL,dtd_genericinclude,NULL,dtb_genericinclude,dtp_genericinclude },
    { "aliasfile",NULL,dtd_aliasfile,NULL,dtb_aliasfile,dtp_aliasfile },
    { "forwardfile",NULL,dtd_forwardfile,NULL,dtb_forwardfile,dtp_forwardfile },
    { "user",NULL,dtd_user,NULL,dtb_user,dtp_user },
    { "altuser",NULL,dtd_altuser,NULL,dtb_altuser,dtp_altuser },
    { "smartuser",NULL,dtd_smartuser,NULL,dtb_smartuser,dtp_smartuser },
    { NULL },
}; 
 
struct route_driver route_drivers[] = {
    { "pathalias",NULL,rtd_pathalias,NULL,rtb_pathalias,rtp_pathalias },
    { "uuname",rtc_uuname,rtd_uuname,rtf_uuname,rtb_uuname,rtp_uuname },
    { "smarthost",NULL,rtd_smarthost,NULL,rtb_smarthost,rtp_smarthost },
    { "reroute",NULL,rtd_reroute,NULL,rtb_reroute,rtp_reroute },
    { "rewrite",NULL,rtd_rewrite,NULL,rtb_rewrite,rtp_rewrite },
    { "queryprogram",NULL,rtd_queryprogram,NULL,rtb_queryprogram,rtp_queryprogram },
    { "gethostbyname",NULL,rtd_gethostbyname,NULL,rtb_gethostbyname,rtp_gethostbyname },
    { "gethostbyaddr",NULL,rtd_gethostbyaddr,NULL,rtb_gethostbyaddr,rtp_gethostbyaddr },
    { "bind",NULL,rtd_bind,NULL,rtb_bind,rtp_bind },
    { NULL },
}; 
 
struct transport_driver transport_drivers[] = {
    { "pipe",NULL,tpd_pipe,NULL,tpb_pipe,tpp_pipe },
    { "appendfile",NULL,tpd_appendfile,NULL,tpb_appendfile,tpp_appendfile },
    { "smtp",NULL,tpd_smtp,NULL,tpb_smtp,tpp_smtp },
    { "tcpsmtp",NULL,tpd_tcpsmtp,NULL,tpb_tcpsmtp,tpp_tcpsmtp },
    { NULL },
}; 
 
